#include"stdio.h"


char flag;
int old,x,y;
int hx,lx,hy,ly;
float scale;

main(argc,argv)
int argc;
char *argv[];

 {
   FILE *fp1;
   char c;

    flag='A';

    if (argc!=3) 
     {
       printf("\n  Syntax : tex file # ; # is a scalefactor [1-10]\n");
       printf("\33[?35l");	/* text cursor ON */
       exit (1);
     }


    if ( (fp1=fopen(argv[1],"r")) == NULL) 
     { 
       printf(" Cant open file to display !\n");
       printf("\33[?35l");	/* text cursor ON */
       exit (1);
     }
    if (argv[2]==NULL)
     {
       printf("\n You must specify the scale factor 1-10\n ");
       printf("\33[?35l");	/* text cursor ON */
       exit(1);
     }

/*   A better way of doing this is to ask the terminal for the current
     resolution by way of outputing {ESC:3n} and get back x and y scale 
     factors. I coulnd't figure out a way to redirect stdout into a string.
     Feel free to improve !!
*/


    scale= (float) atoi(argv[2]);
    scale*=0.1;

    printf("\33:J");		/* Reset text and graphics screens */
    printf("\33[?35h");		/* Turn OFF text cursor 	   */

    while (!feof(fp1)) 
     {
       c=getc(fp1);
       if (c==29) flag='B';
       if (c==12 && old==27)     printf("\33:J"); /*  clear all screens */
       if (c==31) flag='T';
       if (c>31)
         {
/*            if (flag=='T')       putc(c,stdout);   
            else */                graphic(c);
         };

       old=c;		/* save char b4 next for comparisons */
     }

    printf("\33[?35l");	/* text cursor ON */
    fclose(fp1);
    getchar();		/* wait for keyboard input to end it all */
    exit(0);
}

graphic(c)
char c;
 {
    if (c>31 && c<64 && old>95 && old<128)       hx=c;
    else if (c>31 && c<64) 			 hy=c;
    else if (c>95 && c<128)			 ly=c;
    else if (c>63 && c<96)
        {
	  lx=c;
  
          x=(hx-32)*32+lx-64;
          y=(hy-32)*32+ly-96;

/*  If the acctual resolution in the window is known (say wx,wy) then 
    the scale would be [ x*=wx/1024 and y*=wy/780 ]
*/

          x=x*scale;	
          y=y*scale;
   
          if (flag=='A')      printf("\33:%d;%d;0;1d",x,y);
          else                printf("\33:%d;%dm",x,y);

          flag='A';
       }
}
